commit eed230db42b43806a18a6a13b92657f9665367d3
Author: Gaius Mulley <gaiusmod2@gmail.com>
Date:   Tue Nov 26 15:52:55 2024 +0000

    [PATCH] PR modula2/116181 fix ODR warnings for C/m2 interface library modules
    
    This patch fixes many ODR warnings which appear when compiling the
    interface files found in gcc/m2/*-ch/ and gcc/m2/{pge,mc}-boot
    directories.
    
    gcc/m2/ChangeLog:
    
            PR modula2/116181
            * gm2-compiler/ppg.mod (FindStr): Initialize j.
            * gm2-libs-ch/UnixArgs.cc (_M2_UnixArgs_ctor): Replace
            M2RTS_RegisterModule with M2RTS_RegisterModule_Cstr.
            * gm2-libs-ch/dtoa.cc (_M2_dtoa_ctor): Ditto.
            * gm2-libs-ch/ldtoa.cc (ldtoa_strtold): Cast parameter s
            for strtod.
            (_M2_ldtoa_ctor): Replace M2RTS_RegisterModule with
            M2RTS_RegisterModule_Cstr.
            * gm2-libs-ch/m2rts.h (M2RTS_RegisterModule_Cstr): New
            define.
            (M2RTS_RegisterModule): Remove const.
            * mc-boot-ch/GSelective.c (Selective_FdIsSet): Return bool
            rather than int.
            * mc-boot-ch/Gldtoa.cc (ldtoa_strtold): Change const char to
            void.
            Cast s before passing as a parameter to strtod.
            * mc-boot-ch/Glibc.c (tracedb_open): Replace const char with const
            void.
            (libc_perror): Replace char with const char.
            (libc_printf): Replace char with void.
            (libc_snprintf): Replace char with void.
            Add const_cast for parameter to index.
            Add reinterpret_cast for parameter to vsnprintf.
            (libc_open): Replace first paramter type char with void.
            Add vararg for the third parameter.
            * mc-boot-ch/Gm2rtsdummy.cc (M2RTS_RequestDependant): Remove #if 0 code.
            (m2pim_M2RTS_RegisterModule): Change const char parameters to void
            (M2RTS_RegisterModule): Ditto.
            (_M2_M2RTS_init): Remove #if 0 code.
            (M2RTS_ConstructModules): Ditto.
            (M2RTS_Terminate): Ditto.
            (M2RTS_DeconstructModules): Ditto.
            (M2RTS_Halt): Ditto.
            * mc-boot-ch/Gtermios.cc (SetFlag): Return bool.
            * mc-boot-ch/m2rts.h (M2RTS_RegisterModule_Cstr): New define.
            (M2RTS_RegisterModule): Change const char parameters to void.
            * mc-boot/Gdecl.cc: Regenerate.
            * mc/decl.mod (getNextConstExp): Reimplement.
            * pge-boot/GDynamicStrings.cc: Regenerate.
            * pge-boot/GDynamicStrings.h: Ditto.
            * pge-boot/GM2RTS.h (M2RTS_RegisterModule_Cstr): New function.
            (M2RTS_RegisterModule): Reformat.
            * pge-boot/GSymbolKey.cc: Regenerate.
            * pge-boot/GSysExceptions.cc (_M2_SysExceptions_init): Add correct parameters.
            (_M2_SysExceptions_fini): Ditto.
            * pge-boot/GUnixArgs.cc (_M2_UnixArgs_ctor::_M2_UnixArgs_ctor):
            Replace call to M2RTS_RegisterModule with M2RTS_RegisterModuleCstr.
            * pge-boot/Gerrno.cc (_M2_errno_init): Add correct parameters.
            (_M2_errno_fini): Ditto.
            * pge-boot/Gldtoa.cc (ldtoa_strtold): Replace const char with
            void.
            Use reinterpret_cast when passing s to strtod.
            Replace true with TRUE.
            * pge-boot/Gldtoa.h (ldtoa_strtold): Tidy up.
            * pge-boot/Glibc.cc (libc_read): Use size_t as the return type.
            (libc_write): Ditto.
            (libc_strlen): Ditto.
            (libc_perror): Replace char with const char.
            (libc_printf): Replace char to const char.
            Cast parameter to index using const_cast.
            (libc_snprintf): Replace char with void.
            Cast parameter to index using const_cast.
            (libc_malloc): Replace parameter type with size_t.
            (libc_memcpy): Replace third parameter type with size_t.
            (libc_open): Use varargs.
            * pge-boot/Glibc.h (libc_perror): Add _string_high parameter.
            * pge-boot/Gpge.cc: Regenerate.
            * pge-boot/Gtermios.cc (SetFlag): Replace return type with bool.
            (_M2_termios_init): Add correct parameters.
            (_M2_termios_fini): Ditto.
            * pge-boot/m2rts.h (M2RTS_RegisterModule_Cstr): New define.
            (M2RTS_RegisterModule): Replace const char with void.
    
    (cherry picked from commit 9f3b5c2314239e1d3b6e1722e676ea1935bc2836)
    
    Signed-off-by: Gaius Mulley <gaiusmod2@gmail.com>

diff --git a/gcc/m2/gm2-compiler/ppg.mod b/gcc/m2/gm2-compiler/ppg.mod
index fdb5f4369f2..a82c90142a4 100644
--- a/gcc/m2/gm2-compiler/ppg.mod
+++ b/gcc/m2/gm2-compiler/ppg.mod
@@ -3678,6 +3678,7 @@ VAR
 BEGIN
    t := code ;
    k := StrLen(code^.codetext)+1 ;
+   j := StrLen(str) ;
    WHILE t#NIL DO
       REPEAT
          WHILE (k>0) AND IsWhite(t^.codetext[k-1]) DO
diff --git a/gcc/m2/gm2-libs-ch/UnixArgs.cc b/gcc/m2/gm2-libs-ch/UnixArgs.cc
index 574ca581b27..67a0c99f036 100644
--- a/gcc/m2/gm2-libs-ch/UnixArgs.cc
+++ b/gcc/m2/gm2-libs-ch/UnixArgs.cc
@@ -86,6 +86,6 @@ _M2_UnixArgs_dep (void)
 extern "C" void __attribute__((__constructor__))
 _M2_UnixArgs_ctor (void)
 {
-  M2RTS_RegisterModule ("UnixArgs", LIBNAME, _M2_UnixArgs_init, _M2_UnixArgs_finish,
-			_M2_UnixArgs_dep);
+  M2RTS_RegisterModule_Cstr ("UnixArgs", LIBNAME, _M2_UnixArgs_init,
+			     _M2_UnixArgs_finish, _M2_UnixArgs_dep);
 }
diff --git a/gcc/m2/gm2-libs-ch/dtoa.cc b/gcc/m2/gm2-libs-ch/dtoa.cc
index 68e57cffed1..306e70db05b 100644
--- a/gcc/m2/gm2-libs-ch/dtoa.cc
+++ b/gcc/m2/gm2-libs-ch/dtoa.cc
@@ -194,8 +194,8 @@ _M2_dtoa_dep (void)
 extern "C" void __attribute__((__constructor__))
 _M2_dtoa_ctor (void)
 {
-  M2RTS_RegisterModule ("dtoa", LIBNAME, _M2_dtoa_init, _M2_dtoa_finish,
-			_M2_dtoa_dep);
+  M2RTS_RegisterModule_Cstr ("dtoa", LIBNAME, _M2_dtoa_init,
+			     _M2_dtoa_finish, _M2_dtoa_dep);
 }
 
 #else
diff --git a/gcc/m2/gm2-libs-ch/ldtoa.cc b/gcc/m2/gm2-libs-ch/ldtoa.cc
index 2da7a0d8208..9111de1d484 100644
--- a/gcc/m2/gm2-libs-ch/ldtoa.cc
+++ b/gcc/m2/gm2-libs-ch/ldtoa.cc
@@ -52,17 +52,17 @@ extern bool dtoa_calcsign (char *p, int str_size);
    (ndigits may be negative).  */
 
 long double
-ldtoa_strtold (const char *s, bool *error)
+ldtoa_strtold (void *s, bool *error)
 {
   char *endp;
   long double d;
 
   errno = 0;
 #if defined(HAVE_STRTOLD)
-  d = strtold (s, &endp);
+  d = strtold (reinterpret_cast <char *> (s), &endp);
 #else
   /* fall back to using strtod.  */
-  d = (long double)strtod (s, &endp);
+  d = (long double)strtod (reinterpret_cast <char *> (s), &endp);
 #endif
   if (endp != NULL && (*endp == '\0'))
     *error = (errno != 0);
@@ -123,8 +123,8 @@ _M2_ldtoa_dep (void)
 extern "C" void __attribute__((__constructor__))
 _M2_ldtoa_ctor (void)
 {
-  M2RTS_RegisterModule ("ldtoa", LIBNAME, _M2_ldtoa_init, _M2_ldtoa_finish,
-			_M2_ldtoa_dep);
+  M2RTS_RegisterModule_Cstr ("ldtoa", LIBNAME, _M2_ldtoa_init,
+			     _M2_ldtoa_finish, _M2_ldtoa_dep);
 }
 
 #else
diff --git a/gcc/m2/gm2-libs-ch/m2rts.h b/gcc/m2/gm2-libs-ch/m2rts.h
index b6da7cc3539..83e463abf2e 100644
--- a/gcc/m2/gm2-libs-ch/m2rts.h
+++ b/gcc/m2/gm2-libs-ch/m2rts.h
@@ -28,8 +28,13 @@ see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 typedef void (*proc_con) (int, char **, char **);
 typedef void (*proc_dep) (void);
 
+#define M2RTS_RegisterModule_Cstr(MODNAME,LIBNAME,init,fini,dep) \
+  M2RTS_RegisterModule (reinterpret_cast <void *> (const_cast <char *> (MODNAME)), \
+			reinterpret_cast <void *> (const_cast <char *> (LIBNAME)), \
+			init, fini, dep)
+
 extern "C" void M2RTS_RequestDependant (const void *modulename, const void *dependancy);
-extern "C" void M2RTS_RegisterModule (const void *modulename, const void *libname,
+extern "C" void M2RTS_RegisterModule (void *modulename, void *libname,
 				      proc_con init, proc_con fini, proc_dep dependencies);
 extern "C" void _M2_M2RTS_init (void);
 
diff --git a/gcc/m2/mc-boot-ch/GSelective.c b/gcc/m2/mc-boot-ch/GSelective.c
index 6f30bdea47b..26c135b7c7e 100644
--- a/gcc/m2/mc-boot-ch/GSelective.c
+++ b/gcc/m2/mc-boot-ch/GSelective.c
@@ -145,7 +145,7 @@ Selective_FdClr (int fd, fd_set *s)
 /* PROCEDURE FdIsSet (fd: INTEGER; SetOfFd) : BOOLEAN ; */
 
 EXTERN
-int
+bool
 Selective_FdIsSet (int fd, fd_set *s)
 {
   return FD_ISSET (fd, s);
diff --git a/gcc/m2/mc-boot-ch/Gldtoa.cc b/gcc/m2/mc-boot-ch/Gldtoa.cc
index 1e7acb7ad40..ce66fb755fb 100644
--- a/gcc/m2/mc-boot-ch/Gldtoa.cc
+++ b/gcc/m2/mc-boot-ch/Gldtoa.cc
@@ -43,22 +43,22 @@ extern bool dtoa_calcsign (char *p, int str_size);
    (ndigits may be negative).  */
 
 long double
-ldtoa_strtold (const char *s, int *error)
+ldtoa_strtold (void *s, bool *error)
 {
   char *endp;
   long double d;
 
   errno = 0;
 #if defined(HAVE_STRTOLD)
-  d = strtold (s, &endp);
+  d = strtold (reinterpret_cast <char *> (s), &endp);
 #else
   /* fall back to using strtod.  */
-  d = (long double)strtod (s, &endp);
+  d = (long double)strtod (reinterpret_cast <char *> (s), &endp);
 #endif
   if (endp != NULL && (*endp == '\0'))
     *error = (errno != 0);
   else
-    *error = TRUE;
+    *error = true;
   return d;
 }
 
diff --git a/gcc/m2/mc-boot-ch/Glibc.c b/gcc/m2/mc-boot-ch/Glibc.c
index e53a76a0f13..492f17f6bdc 100644
--- a/gcc/m2/mc-boot-ch/Glibc.c
+++ b/gcc/m2/mc-boot-ch/Glibc.c
@@ -67,7 +67,7 @@ tracedb (const char *format, ...)
 
 static
 void
-tracedb_open (const char *p, int flags, mode_t mode)
+tracedb_open (const void *p, int flags, mode_t mode)
 {
 #if defined(BUILD_MC_LIBC_TRACE)
   bool item_written = false;
@@ -161,7 +161,7 @@ libc_exit (int code)
 
 EXTERN
 void
-libc_perror (char *s)
+libc_perror (const char *s, unsigned int length)
 {
   perror (s);
 }
@@ -207,7 +207,7 @@ libc_printf (const char *_format, unsigned int _format_high, ...)
 
   do
     {
-      c = index (&_format[i], '\\');
+      c = index (&const_cast <char *> (_format)[i], '\\');
       if (c == NULL)
         strcpy (&format[j], &_format[i]);
       else
@@ -233,7 +233,7 @@ libc_printf (const char *_format, unsigned int _format_high, ...)
 
 EXTERN
 int
-libc_snprintf (char *dest, size_t length, const char *_format, unsigned int _format_high, ...)
+libc_snprintf (void *dest, size_t length, const char *_format, unsigned int _format_high, ...)
 {
   va_list arg;
   int done;
@@ -244,7 +244,7 @@ libc_snprintf (char *dest, size_t length, const char *_format, unsigned int _for
 
   do
     {
-      c = index (&_format[i], '\\');
+      c = index (&const_cast <char *> (_format)[i], '\\');
       if (c == NULL)
         strcpy (&format[j], &_format[i]);
       else
@@ -263,7 +263,7 @@ libc_snprintf (char *dest, size_t length, const char *_format, unsigned int _for
   while (c != NULL);
 
   va_start (arg, _format_high);
-  done = vsnprintf (dest, length, format, arg);
+  done = vsnprintf (reinterpret_cast<char *> (dest), length, format, arg);
   va_end (arg);
   return done;
 }
@@ -343,11 +343,15 @@ libc_creat (char *p, mode_t mode)
 
 EXTERN
 int
-libc_open (char *p, int flags, mode_t mode)
+libc_open (void *p, int oflag, ...)
 {
-  tracedb_open (p, flags, mode);
-  int result = open (p, flags, mode);
+  va_list arg;
+  va_start (arg, oflag);
+  mode_t mode = va_arg (arg, mode_t);
+  tracedb_open (p, oflag, mode);
+  int result = open (reinterpret_cast <char *> (p), oflag, mode);
   tracedb_result (result);
+  va_end (arg);
   return result;
 }
 
diff --git a/gcc/m2/mc-boot-ch/Gm2rtsdummy.cc b/gcc/m2/mc-boot-ch/Gm2rtsdummy.cc
index f845a31e388..9b431f79dfa 100644
--- a/gcc/m2/mc-boot-ch/Gm2rtsdummy.cc
+++ b/gcc/m2/mc-boot-ch/Gm2rtsdummy.cc
@@ -31,32 +31,17 @@ see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 typedef void (*proc_con) (int, char **, char **);
 typedef void (*proc_dep) (void);
 
-#if 0
-/* Used if -fscaffold-dynamic were selected.  */
-extern "C" void M2RTS_RequestDependant (const char *modulename, const char *libname,
-					const char *dependancy, const char *deplib);
-#endif
-
-extern "C" void m2pim_M2RTS_RegisterModule (const char *modulename, const char *libname,
+extern "C" void m2pim_M2RTS_RegisterModule (void *modulename, void *libname,
 					    proc_con init, proc_con fini, proc_dep dependencies);
 
 /* Fixup references, the code will not be used though, as it is only used if
    -fscaffold-dynamic is selected (and mc uses -fscaffold-static).  */
 
 extern "C"
-void M2RTS_RegisterModule (const char *modulename, const char *libname,
+void M2RTS_RegisterModule (char *modulename, char *libname,
 			   proc_con init, proc_con fini, proc_dep dependencies)
 {
-  m2pim_M2RTS_RegisterModule (modulename, libname, init, fini, dependencies);
+  m2pim_M2RTS_RegisterModule (reinterpret_cast <void *> (modulename),
+			      reinterpret_cast <void *> (libname),
+			      init, fini, dependencies);
 }
-
-#if 0
-extern "C" void _M2_M2RTS_init (void);
-
-extern "C" void M2RTS_ConstructModules (const char *,
-					int argc, char *argv[], char *envp[]);
-extern "C" void M2RTS_Terminate (void);
-extern "C" void M2RTS_DeconstructModules (void);
-
-extern "C" void M2RTS_Halt (const char *, int, const char *, const char *) __attribute__ ((noreturn));
-#endif
diff --git a/gcc/m2/mc-boot-ch/Gtermios.cc b/gcc/m2/mc-boot-ch/Gtermios.cc
index 0ef5c8ba803..99f003f6152 100644
--- a/gcc/m2/mc-boot-ch/Gtermios.cc
+++ b/gcc/m2/mc-boot-ch/Gtermios.cc
@@ -1081,8 +1081,8 @@ EXPORT (GetFlag) (struct termios *t, Flag f, int *b)
 /* SetFlag - sets a flag value in, t, to, b, and returns TRUE if this
    flag value is supported.  */
 
-int
-EXPORT (SetFlag) (struct termios *t, Flag f, int b)
+bool
+EXPORT (SetFlag) (struct termios *t, Flag f, bool b)
 {
   switch (f)
     {
diff --git a/gcc/m2/mc-boot-ch/m2rts.h b/gcc/m2/mc-boot-ch/m2rts.h
index ef09bd71535..bfd2d9f8c45 100644
--- a/gcc/m2/mc-boot-ch/m2rts.h
+++ b/gcc/m2/mc-boot-ch/m2rts.h
@@ -28,9 +28,14 @@ see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 typedef void (*proc_con) (int, char **, char **);
 typedef void (*proc_dep) (void);
 
+#define M2RTS_RegisterModule_Cstr(MODNAME,LIBNAME,init,fini,dep) \
+  M2RTS_RegisterModule (const_cast <void *> (MODNAME), \
+			const_cast <void *> (LIBNAME), \
+			init, fini, dep)
+
 extern "C" void M2RTS_RequestDependant (const char *modulename, const char *libname,
 					const char *dependancy, const char *deplib);
-extern "C" void M2RTS_RegisterModule (const char *modulename, const char *libname,
+extern "C" void M2RTS_RegisterModule (void *modulename, void *libname,
 				      proc_con init, proc_con fini, proc_dep dependencies);
 extern "C" void _M2_M2RTS_init (void);
 
diff --git a/gcc/m2/mc-boot/Gdecl.cc b/gcc/m2/mc-boot/Gdecl.cc
index 183d671c8b3..defe0b29537 100644
--- a/gcc/m2/mc-boot/Gdecl.cc
+++ b/gcc/m2/mc-boot/Gdecl.cc
@@ -6453,7 +6453,7 @@ static decl_node__opaque putFieldRecord (decl_node__opaque r, nameKey_Name tag,
   n->recordfieldF.tag = false;
   n->recordfieldF.scope = static_cast<decl_node__opaque> (NULL);
   initCname (&n->recordfieldF.cname);
-  /* 
+  /*
    IF r^.kind=record
    THEN
       doRecordM2 (doP, r)
@@ -6866,7 +6866,7 @@ static decl_node__opaque makeIntrinsicProc (decl_nodeT k, unsigned int noArgs, d
 {
   decl_node__opaque f;
 
-  /* 
+  /*
    makeIntrisicProc - create an intrinsic node.
   */
   f = newNode (k);
@@ -10084,7 +10084,7 @@ static void doString (mcPretty_pretty p, decl_node__opaque n)
   s = DynamicStrings_InitStringCharStar (nameKey_keyToCharStar (decl_getSymName (static_cast<decl_node> (n))));
   outTextS (p, s);
   s = DynamicStrings_KillString (s);
-  /* 
+  /*
    IF DynamicStrings.Index (s, '"', 0)=-1
    THEN
       outText (p, '"') ;
@@ -10244,7 +10244,7 @@ static void doStringC (mcPretty_pretty p, decl_node__opaque n)
   DynamicStrings_String s;
 
   mcDebug_assert (isString (n));
-  /* 
+  /*
    s := InitStringCharStar (keyToCharStar (getSymName (n))) ;
    IF DynamicStrings.Length (s)>3
    THEN
@@ -10792,7 +10792,7 @@ static void doParamTypeEmit (mcPretty_pretty p, decl_node__opaque paramnode, dec
       doTypeNameC (p, paramtype);
       doOpaqueModifier (p, paramnode);
     }
-  /* 
+  /*
       IF nodeUsesOpaque (paramnode) AND (NOT getNodeOpaqueVoidStar (paramnode))
       THEN
          outText (p, '__opaque')
@@ -13326,7 +13326,7 @@ static void doExternCP (mcPretty_pretty p)
 
 static void doProcedureCommentText (mcPretty_pretty p, DynamicStrings_String s)
 {
-  /* remove 
+  /* remove
    from the start of the comment.  */
   while (((DynamicStrings_Length (s)) > 0) && ((DynamicStrings_char (s, 0)) == ASCII_lf))
     {
@@ -13392,7 +13392,7 @@ static void doProcedureHeadingC (decl_node__opaque n, bool prototype)
     }
   q = static_cast<decl_node__opaque> (NULL);
   doTypeC (doP, n->procedureF.returnType, &q);
-  /* 
+  /*
    IF NOT isExported (n)
    THEN
       doTypeNameModifier (doP, n^.procedureF.returnType)
@@ -14063,7 +14063,7 @@ static void includeDefVarProcedure (decl_node__opaque n)
       defModule = static_cast<decl_node__opaque> (decl_lookupDef (decl_getSymName (static_cast<decl_node> (n))));
       if (defModule != NULL)
         {
-          /* 
+          /*
          includeVar (defModule^.defF.decls) ;
          simplifyTypes (defModule^.defF.decls) ;
   */
@@ -25814,7 +25814,7 @@ extern "C" decl_node decl_makeComponentRef (decl_node rec, decl_node field)
   decl_node__opaque n;
   decl_node__opaque a;
 
-  /* 
+  /*
    n := getLastOp (rec) ;
    IF (n#NIL) AND (isDeref (n) OR isPointerRef (n)) AND
       (skipType (getType (rec)) = skipType (getType (n)))
@@ -26194,8 +26194,6 @@ extern "C" decl_node decl_makeConstExp (void)
 
 extern "C" decl_node decl_getNextConstExp (void)
 {
-  decl_node__opaque n;
-
   mcDebug_assert (((decl_isDef (static_cast<decl_node> (currentModule))) || (decl_isImp (static_cast<decl_node> (currentModule)))) || (decl_isModule (static_cast<decl_node> (currentModule))));
   if (decl_isDef (static_cast<decl_node> (currentModule)))
     {
@@ -26206,12 +26204,12 @@ extern "C" decl_node decl_getNextConstExp (void)
       /* avoid dangling else.  */
       return static_cast<decl_node> (getNextFixup (&currentModule->impF.constFixup));
     }
-  else if (decl_isModule (static_cast<decl_node> (currentModule)))
+  else
     {
       /* avoid dangling else.  */
+      mcDebug_assert (decl_isModule (static_cast<decl_node> (currentModule)));
       return static_cast<decl_node> (getNextFixup (&currentModule->moduleF.constFixup));
     }
-  return static_cast<decl_node> (n);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
diff --git a/gcc/m2/mc/decl.mod b/gcc/m2/mc/decl.mod
index 37fc3962695..8293c7f5d1f 100644
--- a/gcc/m2/mc/decl.mod
+++ b/gcc/m2/mc/decl.mod
@@ -3545,8 +3545,6 @@ END setConstExpComplete ;
 *)
 
 PROCEDURE getNextConstExp () : node ;
-VAR
-   n: node ;
 BEGIN
    assert (isDef (currentModule) OR isImp (currentModule) OR isModule (currentModule)) ;
    WITH currentModule^ DO
@@ -3556,12 +3554,11 @@ BEGIN
       ELSIF isImp (currentModule)
       THEN
          RETURN getNextFixup (impF.constFixup)
-      ELSIF isModule (currentModule)
-      THEN
+      ELSE
+         assert (isModule (currentModule))
          RETURN getNextFixup (moduleF.constFixup)
       END
-   END ;
-   RETURN n
+   END
 END getNextConstExp ;
 
 
